<script lang="ts">
import ChipCounter from '@/components/ChipCounter.vue';
import OrderSummary from "./dashboard/OrderSummary.vue";

import { FactoryState } from '@/model';
import { computed, defineComponent, Ref } from '@vue/composition-api';
import { useState } from "vuex-composition-helpers";

export default defineComponent({
	name: "ProductionState",
	components: { ChipCounter, OrderSummary },
	setup() {
		let state = useState(["assemblyLineState"]).assemblyLineState as Ref<FactoryState>;

		let dense = computed(() => Object.values(state.value.RFIDColorPairs).length > 5);

		return { state, dense }
	}
})
</script>



<template>
	<div class="prod-state-wrapper">
		<div class="header">
			<div class="text-button">
				<v-icon left>mdi-robot-industrial</v-icon>
				Assembly line state
			</div>
		</div>
		<v-divider></v-divider>

		<div class="scroll-container">
			<v-card class="card">
				<h3 class="overline">Color readings</h3>
				<v-list class="d-flex color-readings">
					<chip-counter size="2rem" v-for="({color}, i) of state.colorReadings" :key="i" :color="color"></chip-counter>
				</v-list>
				<v-divider class="separator"></v-divider>
				<h3 class="overline">RFID readings</h3>
				<v-simple-table :dense="dense">
					<template v-slot:default>
						<thead>
							<tr>
								<th class="text-left">
									RFID
								</th>
								<th class="text-left">
									Color
								</th>
							</tr>
						</thead>
						<tbody>
							<tr
								v-for="(color, rfid, i) in state.RFIDColorPairs" :key="i">
								<td><kbd>#{{rfid}}</kbd></td>
								<td>
									<chip-counter size="2rem" :color="color"></chip-counter>
								</td>
							</tr>
						</tbody>
					</template>
				</v-simple-table>
				<v-divider class="separator"></v-divider>
				<h3 class="overline">Active orders</h3>
				<order-summary v-for="order of state.activeOrders" :key="order.id" v-bind="{order}"></order-summary>
				<v-divider class="separator"></v-divider>
				<h3 class="overline">Finished orders</h3>
				<order-summary v-for="order of state.finishedOrders" :key="order.id" v-bind="{order}"></order-summary>
			</v-card>
		</div>
	</div>
</template>

<style scoped>
.prod-state-wrapper {
	display: flex;
	flex-direction: column;
	height: 100%;
}
.header {
	min-width: max-content;
	padding: 0.5em 1em;
}
.scroll-container {
	width: 100%;
	height: 100%;
	overflow: auto;
}
.v-card {
	max-width: 1000px;
	min-width: 400px;
	margin: 5px auto;
	padding: 1em;
}
h3 {
	margin: 1em 0em;
}
.color-readings {
	gap: 10px;
}
.separator {
	margin: 1em 0;
}
</style>